/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"

void readModePin(void);
void readDirectionPins(void);
void sendSerialData(void);

#define westPin          3
#define northPin         4
#define eastPin          5
#define southPin         6
#define modePin          7
#define lowLedPin        24
#define med1LedPin       25
#define med2LedPin       26
#define highLedPin       27

#define rx 0
#define tx 1

char directionFlag      = 0;
char westPinState       = 0;
char lastwestPinState   = 0;
char northPinState      = 0;
char lastnorthPinState  = 0;
char eastPinState       = 0;
char lasteastPinState   = 0;
char southPinState      = 0;
char lastsouthPinState  = 0;
char currentmodeswitchState = 0;
char lastmodeswitchState = 0;
char mode;

unsigned long currentMillis;
unsigned long lastMillis;
volatile char RmotorPin;
volatile char RdirPin;
volatile char DmotorPin;
volatile char DdirPin;

fdserial *fd;


int main()                                    // Main function
{
  low(lowLedPin);                             // Add startup code here.
  low(med1LedPin);
  low(med2LedPin);
  low(highLedPin);
  
  
  fd = fdserial_open(rx, tx, FDSERIAL_MODE_NONE, 115200); 
 
  while(1)
  {
    readModePin();                            // Add main loop code here.
    readDirectionPins();
    pause(50);
    
  } 
}
  //                                        readModePin 
  // ***************************************************************************
void readModePin()
 {
   currentmodeswitchState = input(modePin);
   if(currentmodeswitchState != lastmodeswitchState)
    {
      lastmodeswitchState = currentmodeswitchState;
      if(currentmodeswitchState == 0)
       { 
        mode ++;
        if(mode > 4)
         {
           mode = 1;
         }
       }
       else
       {} 
    }
   switch(mode)
   {
     case 1:
       high(lowLedPin);
       low(med1LedPin);
       low(med2LedPin);
       low(highLedPin);
       break;
       
     case 2:
       low(lowLedPin);
       high(med1LedPin);
       low(med2LedPin);
       low(highLedPin);
       break;
       
     case 3:
       low(lowLedPin);
       low(med1LedPin);
       high(med2LedPin);
       low(highLedPin);
       break;   
       
     case 4:
       low(lowLedPin);
       low(med1LedPin);
       low(med2LedPin);
       high(highLedPin);
       break;
       
     default:
       { }
   } 
 }   
  //                           readDirectionalPins
  // *********************************************************************
void readDirectionPins() 
  {  //0 = none, 1 = west, 2 = north, 3 = east, 4 = south, 5 = reset                          
   westPinState = input(westPin);
   if(westPinState != lastwestPinState)
    {
      lastwestPinState = westPinState;
      if(westPinState == 0)
       {
         directionFlag = 1;
         low(RdirPin);
         low(DdirPin);
       }
     else
       {
         directionFlag = 5;
         low(RmotorPin);
         low(DmotorPin);
         low(RdirPin);
         low(DdirPin);
       }
    }
  // ********************************************************
   northPinState = input(northPin);
   if(northPinState != lastnorthPinState)
   {
     lastnorthPinState = northPinState;
     if(northPinState == 0)
     {
       directionFlag = 2;
       low(RdirPin);
       low(DdirPin);
     }
   else
     {
       directionFlag = 5;
       low(RmotorPin);
       low(DmotorPin);
       low(RdirPin);
       low(DdirPin);
     }
  }
  // ************************************
  eastPinState = input(eastPin);
  if(eastPinState != lasteastPinState)
  {
    lasteastPinState = eastPinState;
    if(eastPinState == 0)
    {
      directionFlag = 3;
      high(RdirPin);
      low(DdirPin);
    }
  else
    {
      directionFlag = 5;
      low(RmotorPin);
      low(DmotorPin);
      low(RdirPin);
      low(DdirPin);
    }
 }
  // ********************************************************
    southPinState = input(southPin);
    if(southPinState != lastsouthPinState)
     {
       lastsouthPinState = southPinState;
       if(southPinState == 0)
        { 
         directionFlag = 4;
         low(RdirPin);
         high(DdirPin);
       }
     else
       {
         directionFlag = 5;
         low(RmotorPin);
         low(DmotorPin);
         low(RdirPin);
         low(DdirPin);
       }
    }
   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
 
   if(directionFlag != 0)
    {
      switch(mode)
       {
         //mode 1
         case 1:
          switch(directionFlag)
           {
             //mode 1
             case 1: 
             {
               RmotorPin      = 100;
               DmotorPin      =   0;
               directionFlag = 0;
             }
              break;
            case 2:
            {
               RmotorPin      =   0;
               DmotorPin      =  75;
              directionFlag = 0;
            }
             break;
            case 3:                                                    
            {
               RmotorPin      = 100;
               DmotorPin      =   0;
              directionFlag = 0; 
            }
             break;
            case 4:
            {
               RmotorPin      =   0;
               DmotorPin      =  75;
              directionFlag = 0;
            }
            break;
        }
          break;
 //++++++++++++
    // mode 2:
    case 2:
     switch(directionFlag)
      {  // mode 2 west
        case 1: 
        {
          RmotorPin      = 150;
          DmotorPin      =   0;
          directionFlag = 0;
        }
          break;
        case 2:
        {
          RmotorPin      =   0;
          DmotorPin      = 100;
          directionFlag = 0;
        }
          break;
        case 3:
        {
          RmotorPin      = 150;
          DmotorPin      =   0;
          directionFlag = 0;
        }
          break;
        case 4:
        {
          RmotorPin      =   0;
          DmotorPin      = 100;
          directionFlag = 0;
        }
          break;
      }
        break;
 //++++++++++++++++++++++++++++++++++++++++++++++++++++++
    // mode  3:
    case 3:
      switch(directionFlag)
       { // mode 3 west
         case 1:
         {
           RmotorPin      = 200;
           DmotorPin      =   0;
           directionFlag = 0;
         } 
           break;
         case 2:
         {
           RmotorPin      =   0;
           DmotorPin      = 150; 
           directionFlag = 0;
         }
           break;
         case 3:
         {
           RmotorPin      = 200;
           DmotorPin      =   0;
           directionFlag = 0;
         }
           break;
         case 4:
         {
           RmotorPin      =   0;
           DmotorPin      = 150;
           directionFlag = 0;
         }
           break;
     }
       break;
 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   // mode 4:
   case 4:
    switch(directionFlag)
    {  // west
       case 1:
       {
         RmotorPin      = 250;
         DmotorPin      =   0;
         directionFlag = 0;
       }  
         break;
       case 2:
       {
         RmotorPin      =   0; 
         DmotorPin      = 200;
         directionFlag = 0;
       }
         break;
       case 3:
       {
         RmotorPin      = 250;
         DmotorPin      =   0;
         directionFlag = 0;
       }
         break;
       case 4:
       {
         RmotorPin      =   0;
         DmotorPin      = 200;
         directionFlag = 0;
       }
         break;
     }
       break;
   }
 //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if(directionFlag == 5)
    {
      directionFlag = 0;
    }
   }
  }     
  // ****************************************************
 void sendSerialData()
   {
     fdserial_txChar(fd, RmotorPin);
     fdserial_txChar(fd, RdirPin);
     fdserial_txChar(fd, DmotorPin);
     fdserial_txChar(fd, DdirPin);
     
     printi("value1: %d, value2: %d, value3: %d, value4: %d\n", RmotorPin, RdirPin, DmotorPin, DdirPin);
  }                                                                                                                        
                                                                                                                                                                                          
  